//Ejemplo para guardar y evaluar un polinomio
//usando la coleccion LinkedList del API de Java
import java.awt.geom.*;
import java.util.*;
import static javax.swing.JOptionPane.*;
public class Polinomio {
	//Uso de la estructura de datos lista enlazada del api de java
    static LinkedList<Termino> polinomio=new LinkedList<Termino>();
	public static void main(String[] args) {
		try{
	       int grado=Integer.parseInt(showInputDialog("Grado del polinomio:"));
	       double coef,expo;Termino termino;
	       for (int i=grado;i>=0;i--) //Pedir los terminos del polinomio
	       {   coef=Double.parseDouble(showInputDialog("Coeficiente de grado "+i+":"));
	            expo=i;
	            termino=new Termino(coef,expo); //Crea instancia del termino
	            //Dar de alta el nodo en la lista enlazada
	            polinomio.add(termino);
	       } 
	       //Evaluar polinomio
	       double xmin=Double.parseDouble(showInputDialog("Valor de x inicial:"));
	       double ymin=Double.parseDouble(showInputDialog("Valor de y inicial:"));
	       double xmax=-xmin;
	       Point2D.Double[] puntos=new Point2D.Double[700];
	     //Cuanto valdria en coordendas reales un pixel
	       double incremento=(xmax-xmin)/puntos.length; 
	       //Recorrer los nodos de la lista y sumar los terminos
	       double x=xmin;
	       for (int i=0;i<puntos.length;i++){ //Generar los 700 puntos para la grafica
            double suma=0.0;
            //for (int i=0;i<polinomio.size();i++)
	       for (Termino t:polinomio){ //for each
	    	     suma=suma+t.evaluar(x);
	       }
	       puntos[i]=new Point2D.Double(x, suma);
	       x=x+incremento;
	       System.out.printf("(%5.2f,%5.2f)\n",puntos[i].getX(),puntos[i].getY());
	       }
	       Lienzo grafico=new Lienzo(xmin,ymin,700,700,puntos);
		} catch (Exception ex){
			showMessageDialog(null,"Datos incorrectos");
		}
	}
}
